--这个文件是借来抄的，实际运行并不使用这个

AddStategraphActionHandler("wilson", 
    ActionHandler(ACTIONS.ATTACK,
        function(this, action)
            this.sg.mem.localchainattack = not action.forced or nil
            if not (this.sg:HasStateTag("attack") and action.target == this.sg.statemem.attacktarget or this.components.health:IsDead()) then
                local weapon = this.components.combat ~= nil and this.components.combat:GetWeapon() or nil
                return (weapon == nil and "attack")
                    or (weapon:HasTag("blowdart") and "blowdart")
                    or (weapon:HasTag("thrown") and "throw")
                    or (weapon:HasTag("multithruster") and "multithrust_pre")
					or (weapon:HasTag("gauss_gun_attack") and "gauss_gun_normalattack")
					or (weapon:HasTag("firebat_attack") and "firebat_attack")
					or (weapon:HasTag("g11_attack") and "g11_attack")
                    or "attack"
            end
        end)
)

AddStategraphActionHandler("wilson_client", 
     ActionHandler(ACTIONS.ATTACK,
        function(this, action)
            if not (this.sg:HasStateTag("attack") and action.target == this.sg.statemem.attacktarget or this.replica.health:IsDead()) then
                local equip = this.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
                if equip == nil then
                    return "attack"
                end
                local inventoryitem = equip.replica.inventoryitem
                return (not (inventoryitem ~= nil and inventoryitem:IsWeapon()) and "attack")
                    or (equip:HasTag("blowdart") and "blowdart")
                    or (equip:HasTag("thrown") and "throw")
					or (equip:HasTag("gauss_gun_attack") and "gauss_gun_normalattack")
					or (equip:HasTag("firebat_attack") and "firebat_attack")
					or (equip:HasTag("sgtag_m16fire") and "sgtag_m16fire")
                    or "attack"
            end
        end)
)

local function dogunfire(this,target,len,high,future)
	if not this or not this:IsValid() or not target or not target:IsValid() then 
		return
	end
	this.SoundEmitter:PlaySound("fa/m16a4/fire","m16firing")--我下次再问一下这个函数的参数
end 

local function dogunattack(this,equip,target,tag)
	if not this or not this:IsValid() or not target or not target:IsValid() then 
		return
	end
	local pos = target:GetPosition()
	if equip.components.finiteuses:GetUses() > 0 and not target.components.health:IsDead() and this.sg:HasStateTag(tag) then 
		this.components.combat:DoAttack(target)
	--[[	if target:HasTag("chess")	 then 
			local sparksb = SpawnPrefab("sparks")
			sparksb.Transform:SetPosition(pos.x,pos.y,pos.z)
			sparksb.Transform:SetScale(1.3,1.3,1.3)
		end	
		if not target:HasTag("chess") and not target:HasTag("nightmare") then 
			local blood = SpawnPrefab("gunblood")
			blood.Transform:SetPosition(pos.x,pos.y,pos.z)
			blood.Transform:SetScale(0.4,0.4,0.4)
		end --]]
	end 
end 

AddStategraphState("wilson", 
 State{
		name = "sgtag_m16fire",
        tags = { "attack", "notalking", "abouttoattack", "autopredict" ,"sg_g11_attack"},
		onenter = a,
		    timeline =
    {
	
	    TimeEvent(0.1, function(this)
			local buffaction = this:GetBufferedAction()
			local target = buffaction ~= nil and buffaction.target or nil
			if target ~= nil then 
				local equip = this.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
				this.AnimState:PushAnimation("fishing_pst", false)
				dogunfire(this,target,2.5,1.5,false)
				dogunattack(this,equip,target,"sg_g11_attack")
			end 
        end),
	
        TimeEvent(6 * FRAMES, function(this)
            if this.sg.statemem.isbeaver then
                this:PerformBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            elseif this.sg.statemem.ischop then
                this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
            end
        end),
        TimeEvent(8 * FRAMES, function(this)
			local buffaction = this:GetBufferedAction()
			local target = buffaction ~= nil and buffaction.target or nil
			if target ~= nil then 
				local equip = this.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
				this.AnimState:PushAnimation("fishing_pst", false)
				--dogunfire(this,target,2.5,1.5,false)
				dogunattack(this,equip,target,"sg_g11_attack")
			end 
            if not (this.sg.statemem.isbeaver or
                    this.sg.statemem.iswhip or
                    this.sg.statemem.isbook) and
                this.sg.statemem.projectiledelay == nil then
                this:PerformBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
        TimeEvent(10 * FRAMES, function(this)
			dogunfire(this,target,2.5,1.5,false)
			dogunattack(this,equip,target,"sg_g11_attack")
            if this.sg.statemem.iswhip or this.sg.statemem.isbook then
                this:PerformBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),

    },

    ontimeout = function(this)
        this.sg:RemoveStateTag("attack")
		this.sg:RemoveStateTag("sg_g11_attack")
        this.sg:AddStateTag("idle")
    end,

    events =
    {
        EventHandler("equip", function(this) this.sg:GoToState("idle") this.sg:RemoveStateTag("sg_g11_attack")end),
        EventHandler("unequip", function(this) this.sg:GoToState("idle")  this.sg:RemoveStateTag("sg_g11_attack")end),
        EventHandler("animqueueover", function(this)

            if this.AnimState:AnimDone() then
				this.sg:RemoveStateTag("sg_g11_attack")
                this.sg:GoToState("idle")
            end
        end),
    },

    onexit = function(this)
        this.components.combat:SetTarget(nil)
		this.sg:RemoveStateTag("sg_g11_attack")
        if this.sg:HasStateTag("abouttoattack") then
            this.components.combat:CancelAttack()
        end
    end,
		
}
)

AddStategraphState("wilson_client",
	State{
	name = "gauss_gun_normalattack",
    tags = { "attack", "notalking", "abouttoattack" },

    onenter = function(this)
	print("窝要搞死你啊_client!")
        local cooldown = 0
		local buffaction = this:GetBufferedAction()
        local target = buffaction ~= nil and buffaction.target or nil
        if this.replica.combat ~= nil then
            this.replica.combat:StartAttack()
            cooldown = this.replica.combat:MinAttackPeriod() + .5 * FRAMES
        end
        this.components.locomotor:Stop()
        local equip = this.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	if target ~= nil then
		local pos = target:GetPosition()
			local my = this:GetPosition()
			local a = pos.x - my.x
			local c = pos.z - my.z
			local ma = 2.5*a/math.sqrt(a*a+c*c)
			local mc = 2.5*c/math.sqrt(a*a+c*c)
			this.AnimState:PlayAnimation("fishing_pst")
			this:DoTaskInTime(0.1,
			function(this)
			local sparksa = SpawnPrefab("sparks")
			sparksa.Transform:SetPosition(my.x+ma,0,my.z+mc)
			sparksa.Transform:SetScale(1.3,1.3,1.3)
			local gunfire = SpawnPrefab("gunfire")
			gunfire.Transform:SetPosition(my.x+ma,0,my.z+mc)
			gunfire.Transform:SetScale(1.3,1.3,1.3)
			--this.components.combat:DoAttack(target)
		if target:HasTag("chess")	 then 
			local sparksb = SpawnPrefab("sparks")
			sparksb.Transform:SetPosition(pos.x,pos.y,pos.z)
			sparksb.Transform:SetScale(1.3,1.3,1.3)
		end	
		if not target:HasTag("chess") and not target:HasTag("nightmare") then 
			local blood = SpawnPrefab("gunblood")
			blood.Transform:SetPosition(pos.x,pos.y,pos.z)
			blood.Transform:SetScale(0.4,0.4,0.4)
		end 
			
			this.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
			--target.components.health:DoDelta(-100)
            this.AnimState:PushAnimation("idle", false)
			end
			)
			
           -- this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
     
            if cooldown > 0 then
				cooldown = math.max(cooldown, 100 * FRAMES)                              
            end
			
		local buffaction = this:GetBufferedAction()
        if buffaction ~= nil then
            this:PerformPreviewBufferedAction()

            if buffaction.target ~= nil and buffaction.target:IsValid() then
                this:FacePoint(buffaction.target:GetPosition())
                this.sg.statemem.attacktarget = buffaction.target
            end
        end

        if cooldown > 0 then
            this.sg:SetTimeout(cooldown)
        end
	end 
	end,
	    onupdate = function(this, dt)
        if (this.sg.statemem.projectiledelay or 0) > 0 then
            this.sg.statemem.projectiledelay = this.sg.statemem.projectiledelay - dt
            if this.sg.statemem.projectiledelay <= FRAMES then
                if this.sg.statemem.projectilesound ~= nil then
                    this.SoundEmitter:PlaySound(this.sg.statemem.projectilesound, nil, nil, true)
                    this.sg.statemem.projectilesound = nil
                end
                if this.sg.statemem.projectiledelay <= 0 then
                    this:ClearBufferedAction()
                    this.sg:RemoveStateTag("abouttoattack")
                end
            end
        end
    end,

    timeline =
    {
        TimeEvent(6 * FRAMES, function(this)
            if this.sg.statemem.isbeaver then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            elseif this.sg.statemem.ischop then
                this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
            end
        end),
        TimeEvent(8 * FRAMES, function(this)
            if not (this.sg.statemem.isbeaver or
                    this.sg.statemem.iswhip or
                    this.sg.statemem.isbook) and
                this.sg.statemem.projectiledelay == nil then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
        TimeEvent(10 * FRAMES, function(this)
            if this.sg.statemem.iswhip or this.sg.statemem.isbook then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
    },

    ontimeout = function(this)
        this.sg:RemoveStateTag("attack")
        this.sg:AddStateTag("idle")
    end,

    events =
    {
        EventHandler("animqueueover", function(this)
            if this.AnimState:AnimDone() then
			
                this.sg:GoToState("idle")
            end
        end),
    },

    onexit = function(this)
        if this.sg:HasStateTag("abouttoattack") and this.replica.combat ~= nil then
            this.replica.combat:CancelAttack()
        end
    end,
}
)

AddStategraphState("wilson_client", 
	State{
		name="firebat_attack",
		tags = {  "attack", "notalking", "abouttoattack"},
		 onenter = function(this)
	--print("窝要搞死你啊_client!")
        local cooldown = 0
		local buffaction = this:GetBufferedAction()
        local target = buffaction ~= nil and buffaction.target or nil
        if this.replica.combat ~= nil then
            this.replica.combat:StartAttack()
            cooldown = this.replica.combat:MinAttackPeriod() + .5 * FRAMES
        end
        this.components.locomotor:Stop()
        local equip = this.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	if target ~= nil then
			this.AnimState:PlayAnimation("fishing_idle")
			--target.components.health:DoDelta(-100)
            this.AnimState:PushAnimation("idle", false)
		
		
           -- this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
     
            if cooldown > 0 then
				cooldown = math.max(cooldown, 100 * FRAMES)                              
            end
			
		local buffaction = this:GetBufferedAction()
        if buffaction ~= nil then
            this:PerformPreviewBufferedAction()

            if buffaction.target ~= nil and buffaction.target:IsValid() then
                this:FacePoint(buffaction.target:GetPosition())
                this.sg.statemem.attacktarget = buffaction.target
            end
        end

        if cooldown > 0 then
            this.sg:SetTimeout(cooldown)
        end
	end 
	end,
	    onupdate = function(this, dt)
        if (this.sg.statemem.projectiledelay or 0) > 0 then
            this.sg.statemem.projectiledelay = this.sg.statemem.projectiledelay - dt
            if this.sg.statemem.projectiledelay <= FRAMES then
                if this.sg.statemem.projectilesound ~= nil then
                    this.SoundEmitter:PlaySound(this.sg.statemem.projectilesound, nil, nil, true)
                    this.sg.statemem.projectilesound = nil
                end
                if this.sg.statemem.projectiledelay <= 0 then
                    this:ClearBufferedAction()
                    this.sg:RemoveStateTag("abouttoattack")
                end
            end
        end
    end,

    timeline =
    {
	
		TimeEvent(5*FRAMES, function(this) 
				this.AnimState:PlayAnimation("fishing_pst")
				this.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo") 
				end ),
        TimeEvent(6 * FRAMES, function(this)
            if this.sg.statemem.isbeaver then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            elseif this.sg.statemem.ischop then
                this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
            end
        end),
        TimeEvent(8 * FRAMES, function(this)
            if not (this.sg.statemem.isbeaver or
                    this.sg.statemem.iswhip or
                    this.sg.statemem.isbook) and
                this.sg.statemem.projectiledelay == nil then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
        TimeEvent(10 * FRAMES, function(this)
            if this.sg.statemem.iswhip or this.sg.statemem.isbook then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
    },

    ontimeout = function(this)
        this.sg:RemoveStateTag("attack")
        this.sg:AddStateTag("idle")
    end,

    events =
    {
        EventHandler("animqueueover", function(this)
            if this.AnimState:AnimDone() then
			
                this.sg:GoToState("idle")
            end
        end),
    },

    onexit = function(this)
        if this.sg:HasStateTag("abouttoattack") and this.replica.combat ~= nil then
            this.replica.combat:CancelAttack()
        end
    end,
	}
)
AddStategraphState("wilson_client",
	State{
	name = "g11_attack",
    tags = { "attack", "notalking", "abouttoattack","sg_g11_attack" },

    onenter = function(this)
	print("窝要搞死你啊_client!")
        local cooldown = 0
		local buffaction = this:GetBufferedAction()
        local target = buffaction ~= nil and buffaction.target or nil
        if this.replica.combat ~= nil then
            this.replica.combat:StartAttack()
            cooldown = this.replica.combat:MinAttackPeriod() + .5 * FRAMES
        end
        this.components.locomotor:Stop()
        local equip = this.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	if target ~= nil then
			this.AnimState:PlayAnimation("fishing_idle")	
            if cooldown > 0 then
				cooldown = math.max(cooldown,15 * FRAMES)                              
            end
			
		local buffaction = this:GetBufferedAction()
        if buffaction ~= nil then
            this:PerformPreviewBufferedAction()

            if buffaction.target ~= nil and buffaction.target:IsValid() then
                this:FacePoint(buffaction.target:GetPosition())
                this.sg.statemem.attacktarget = buffaction.target
            end
        end

        if cooldown > 0 then
            this.sg:SetTimeout(cooldown)
        end
	end 
	end,
	    onupdate = function(this, dt)
        if (this.sg.statemem.projectiledelay or 0) > 0 then
            this.sg.statemem.projectiledelay = this.sg.statemem.projectiledelay - dt
            if this.sg.statemem.projectiledelay <= FRAMES then
                if this.sg.statemem.projectilesound ~= nil then
                    this.SoundEmitter:PlaySound(this.sg.statemem.projectilesound, nil, nil, true)
                    this.sg.statemem.projectilesound = nil
                end
                if this.sg.statemem.projectiledelay <= 0 then
                    this:ClearBufferedAction()
                    this.sg:RemoveStateTag("abouttoattack")
                end
            end
        end
    end,

    timeline =
    {
	
	    TimeEvent(0.1, function(this)
			this.AnimState:PushAnimation("fishing_pst", false)
        end),

        TimeEvent(6 * FRAMES, function(this)
            if this.sg.statemem.isbeaver then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            elseif this.sg.statemem.ischop then
                this.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
            end
        end),
        TimeEvent(8 * FRAMES, function(this)
            if not (this.sg.statemem.isbeaver or
                    this.sg.statemem.iswhip or
                    this.sg.statemem.isbook) and
                this.sg.statemem.projectiledelay == nil then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
        TimeEvent(10 * FRAMES, function(this)
            if this.sg.statemem.iswhip or this.sg.statemem.isbook then
                this:ClearBufferedAction()
                this.sg:RemoveStateTag("abouttoattack")
            end
        end),
    },

    ontimeout = function(this)
        this.sg:RemoveStateTag("attack")
		this.sg:RemoveStateTag("sg_g11_attack")
        this.sg:AddStateTag("idle")
    end,

    events =
    {
        EventHandler("animqueueover", function(this)
            if this.AnimState:AnimDone() then
				this.sg:RemoveStateTag("sg_g11_attack")
                this.sg:GoToState("idle")
            end
        end),
    },

    onexit = function(this)
		this.sg:RemoveStateTag("sg_g11_attack")
        if this.sg:HasStateTag("abouttoattack") and this.replica.combat ~= nil then
            this.replica.combat:CancelAttack()
        end
    end,
}
)

