﻿[array]$targets = "anim","bigportraits","images","scripts","sound","LICENSE","README.md","modinfo.lua","modinfo_chs.lua","modmain.lua","modinfo_chs test.lua",
            "modicon.tex","modicon.xml"
$proj = Get-Location;
$buildout = [io.path]::GetFullPath("$proj\..\fa_test")
$autocompiler = "$proj\..\..\..\Don't Starve Mod Tools\mod_tools\autocompiler.exe"
$autocompiler = [System.IO.Path]::GetFullPath($autocompiler)

Write-Output "
清理输出文件夹"
Remove-Item -Path $buildout -Force -Recurse

New-Item -Force -ItemType "Directory" "$buildout"
Write-Output "
复制文件"
foreach ($target in $targets)
{
    try
    {
        [System.IO.Path]::Combine($proj,$target) | Copy-Item -PassThru -Destination $buildout -Recurse -Exclude "*.psd",".gitignore" | Write-Host
    }
    catch
    {
        Write-Host "缺少文件",$target
    }
}

#测试文件开始
Remove-Item -Path "$buildout\modinfo_chs.lua" -Force
Rename-Item -Path "$buildout\modinfo_chs test.lua" -NewName "modinfo_chs.lua" -Force
#测试文件结束

Write-Host "
尝试编译动画、图片"
try
{
    Start-Process -FilePath $autocompiler -NoNewWindow -Wait
}
catch
{
    Write-Host "警告：未正确安装Don't strave mod tools，无法编译动画"
}
Write-Host "
移除不必要的文件"
Get-ChildItem "$buildout" -Recurse -Filter "*.png" | Remove-Item -Force