local inspectdesc = "this is your personal weapon, you can modifiy it as you see fit"
local assets = {
    Asset('ANIM', 'anim/m9.zip'),
    Asset('ANIM', 'anim/swap_m9.zip'),
    Asset('IMAGE', 'images/inventoryimages/m9.tex'),
    Asset('ATLAS', 'images/inventoryimages/m9.xml')
}
local projectlleAssets = {
    Asset('ANIM', 'anim/nato556proj.zip')
}

local function onequip(this,owner)
    owner.AnimState:OverrideSymbol('swap_object', 'swap_m16a4', 'swap_m16a4')
    owner.AnimState:Show('ARM_carry')
    owner.AnimState:Hide('ARM_normal')
end

local function onunequip(this, owner)
    owner.AnimState:Hide('ARM_carry')
    owner.AnimState:Show('ARM_normal')
end

local function acceptTest(this,item)
    return item.prefab == '9mmpara' 
        and (this.components.finiteuses:GetUses() < 15)
end

local function onlaunch(this, weapon, target)
    weapon.SoundEmitter:PlaySound('fa/m9/fire')
    --local bullet = SpawnPrefab()
end

local function onattack_noammo(this, owner, target)
    this.components.finiteuses:SetUses(0)
    this.components.weapon:SetDamage(39)
    this.components.weapon:SetRange(1, 1)
    this.components.weapon:SetProjectile(nil)
    --print("无弹药")
end

-- local function reflex(lib)
--     for k,v in pairs(lib) do
--         print(k..",typeid = "..type(v))
--     end
-- end

-- function reflex_2(tlb,typeid)
--     for k, v in pairs(tlb) do
--         if type(v) == typeid then
--             print(k)
--         end
--     end
-- end

local function set_weaponprop(this)
    local v = TUNING.FA
    this.components.weapon:SetDamage(v.DMG_M9)
    this.components.weapon:SetRange(v.RANGE_M9, v.RANGE_M9)
    this.components.weapon:SetProjectile('nato556proj')
end

local function onattack(this)
    if this.components.finiteuses:GetUses() <= 1 then
        this.components.weapon.onattack = onattack_noammo
        print('[M16A4.lua]\n\tonattack=onattack_noammo')
    end
end

local function on_refuse(this,giver,item)
    if item.prefab == "9mmpara" then
        giver.components.talker:Say("15/15")
    else
        giver.components.talker:Say('方式不对')
    end
end

local function on_getitem(this,giver,item)
    if this.components.finiteuses then
        this.components.finiteuses.current = this.components.finiteuses.current + 1
        this:PushEvent('percentusedchange', {percent = this.components.finiteuses:GetPercent()})

        this.components.weapon:SetProjectile('nato556proj')
        this.components.weapon.onattack = onattack
        ----------------------------------------
         m19_normal(this)
        ----------------------------------------
    else
        print('[m9.lua]\t异常：传入的this没有finiteuses组件')
    end
end
