PrefabFiles = {
	"fa",
	"M16A4",
	"nato556"
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/fa.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/fa.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/fa.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/fa.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/fa_none.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/fa_none.xml" ),
    
    Asset( "IMAGE", "bigportraits/fa.tex" ),
    Asset( "ATLAS", "bigportraits/fa.xml" ),

	Asset( "IMAGE", "bigportraits/fa_none.tex" ),
    Asset( "ATLAS", "bigportraits/fa_none.xml" ),
    
	Asset( "IMAGE", "images/map_icons/fa.tex" ),
	Asset( "ATLAS", "images/map_icons/fa.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_fa.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_fa.xml" ),
    ---------------------SND PART----------------
        Asset("SOUNDPACKAGE", "sound/fa.fev"),--
    Asset("SOUND", "sound/m16a4.fsb"),--Sound Bank,只做了开火音效
	--------------------------------------------------
	Asset( "IMAGE", "images/inventoryimages/M16A4.tex" ),
    Asset( "ATLAS", "images/inventoryimages/M16A4.xml" ),

	Asset( "IMAGE", "images/inventoryimages/nato556.tex" ),
    Asset( "ATLAS", "images/inventoryimages/nato556.xml" ),
    
    
    Asset("ANIM","anim/fa.zip"),
    Asset("ANIM","anim/m16a4.zip"),
	Asset("ANIM","anim/nato556.zip"),
	Asset("ANIM","anim/nato556proj.zip"),
}

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
--local Recipe = GLOBAL.Recipe
local TECH = GLOBAL.TECH

local TUNING = GLOBAL.TUNING
-- local ThePlayer = GLOBAL.ThePlayer
-- local TheNet = GLOBAL.TheNet
-- local IsServer = GLOBAL.TheNet:GetIsServer()
-- local TheInput = GLOBAL.TheInput
-- local TimeEvent = GLOBAL.TimeEvent
-- local FRAMES = GLOBAL.FRAMES
-- local EQUIPSLOTS = GLOBAL.EQUIPSLOTS
-- local EventHandler = GLOBAL.EventHandler
-- local SpawnPrefab = GLOBAL.SpawnPrefab
-- local State = GLOBAL.State
-- local DEGREES = GLOBAL.DEGREES
-- local Vector3 = GLOBAL.Vector3
-- local ACTIONS = GLOBAL.ACTIONS
-- local FOODTYPE = GLOBAL.FOODTYPE
-- local PLAYERSTUNLOCK = GLOBAL.PLAYERSTUNLOCK
-- local GetTime = GLOBAL.GetTime
-- local HUMAN_MEAT_ENABLED = GLOBAL.HUMAN_MEAT_ENABLED
-- local TheSim = GLOBAL.TheSim
-- local ActionHandler = GLOBAL.ActionHandler

TUNING.FA=
{
	BTMODE = false,
	BTPLUS = false, --BT加强版
	XS = false   --搞事版
}
-- GLOBAL.WordPredictor:AddDictionary("c_rldpkg")

-- function c_rldpkg(name)
-- 	package.loaded[name] = nil;
-- 	require(name);
-- end

local function SetBT(boolean)
	TUNING.BTMODENABLED = boolean
	if boolean and TUNING.BTMODS ~= nil and type(TUNING.BTMODS) == table then
		table.insert( TUNING.BTMODS,"Fa♂鸽" )
	elseif boolean then
		TUNING.BTMODS = {"Fa♂鸽"}
	end
end

--传入布尔值
function TUNING.FA.SetBTPlus(boolean)
	TUNING.FA.BTPlusMode = boolean
	
	if boolean then
		SetBT(boolean)
	end
end


local function table_merge(t1, t2)
	for k, v in pairs(t2) do
		t1[k] = v
	end
end
---------------------------------正片---------------------------------

STRINGS.CHARACTER_TITLES.fa = "鸽王"
STRINGS.CHARACTER_NAMES.fa = "Fa鸽"
STRINGS.CHARACTER_DESCRIPTIONS.fa = 
[[*Fa鸽
*本体鸽子
*叛乱玩家]]
STRINGS.CHARACTER_QUOTES.fa = "*\"咕咕咕，咕咕，咕咕咕咕咕\""
STRINGS.CHARACTERS.fa = require("speech_fa")
STRINGS.NAMES.fa = "Fa鸽"

TUNING.FA.MODE=GetModConfigData("mode")
print("[Fa鸽] MODE = " .. TUNING.FA.MODE)
SetBT(TUNING.FA.MODE == "BT")

STRINGS.CHARACTERS.GENERIC.DESCRIBE.FA = 
{
	GENERIC = "画风奇怪的鸽子",
	ATTACKER = "rua!",
	MURDERER = "苟来的",
	REVIVER = "谢谢兄弟，已经活了",
	GHOST = "拿电来",
}


table_merge(TUNING.FA, GLOBAL.require('values'))

---------------------------------------PASS-------------------------------------------
AddRecipe(
	"m16a4",
	{
	Ingredient("goldnugget",3),
	Ingredient("rocks",5),
	Ingredient("flint",4)},
	RECIPETABS.WAR,
	TECH.NONE,
	nil,
	nil,
	nil,
	nil,
	"fa",
	"images/inventoryimages/M16A4.xml", 
	"M16A4.tex" 
)

STRINGS.NAMES.M16A4 = "M16A4"
STRINGS.RECIPE_DESC.M16A4 = "素质三连发"
---------------------
AddRecipe(
		"nato556",
		{
			Ingredient("goldnugget",2),
			Ingredient("charcoal",2),
			Ingredient("nitre",1),
		},
			RECIPETABS.WAR,
		TECH.NONE,
		nil,
		nil,
		nil,
		10,
		"fa",
		"images/inventoryimages/nato556.xml", 
		"nato556.tex" 
)

STRINGS.NAMES.NATO556 = "5.56花生米"
STRINGS.RECIPE_DESC.NATO556 = "5.56花生米"
-----------------------------------------------------------------------------------


AddMinimapAtlas("images/map_icons/fa.xml")

AddModCharacter("fa", "MALE")

