local v = {
    DMG_M16 = 57,
    VELOCITY_556 = 430,
    RANGE_M16 = 17,

    FA_HP = 200,
    FA_HUNGER = 200,
    FA_SAN = 170,

    FA_DMG_MULTIPLIER = 1,
    FA_NEG_AURA_MULTIPLIER = 1,
    FA_NIGHT_DRAIN_MULTIPLIER = 0.8,
    FA_DAPPERNESS = 0.05,

    FA_HUNGER_RATE = 0.75 * TUNING.WILSON_HUNGER_RATE,
    FA_SPEED = TUNING.WILSON_RUN_SPEED * 1.1,
    FA_TECHBONUS = 1,

    DMG_M9 = 43,
    VELOCITY_9MM = 220,
    RANGE_M9 = 6,
    CLIPSIZE_M9 = 15,

    START_INV ={"M16A4"}
-----------------------
}

table.insert(v.START_INV, 24, 'nato556')


if TUNING.FA.MODE == "BT" then
    print('============bt版数值============')
    v = {
        DMG_M16 = 100,
        VELOCITY_556 = 500,
        RANGE_M16 = 23,

        FA_HUNGER = 250,
        FA_SAN = 200,
        FA_HP = 200,

        FA_DMG_MULTIPLIER = 1.3,
        FA_NEG_AURA_MULTIPLIER = 0.5,
        FA_NIGHT_DRAIN_MULTIPLIER = 0,

        FA_HUNGER_RATE = 0.55 * TUNING.WILSON_HUNGER_RATE,
        FA_SPEED = TUNING.WILSON_RUN_SPEED * 1.775,
        FA_TECHBONUS = 2,

        DMG_M9 = 71,
        VELOCITY_9MM = 340,
        RANGE_M9 = 12,
        CLIPSIZE_M9 = 15,
        
        START_INV ={"M16A4"},
    }

    table.insert(v.START_INV, 80, 'nato556')
    
end

if TUNING.FA.MODE == "weak" then
    print('============受苦版数值============')
    v = {
        DMG_M16 = 57,
        VELOCITY_556 = 430,
        RANGE_M16 = 17,
    
        FA_HP = 150,
        FA_HUNGER = 150,
        FA_SAN = 120,
    
        FA_DMG_MULTIPLIER = 1,
        FA_NEG_AURA_MULTIPLIER = 1,
        FA_NIGHT_DRAIN_MULTIPLIER = 1,
        FA_DAPPERNESS = 0,
    
        FA_HUNGER_RATE = 0.8 * TUNING.WILSON_HUNGER_RATE,
        FA_SPEED = TUNING.WILSON_RUN_SPEED * 1.05,
        FA_TECHBONUS = 1,
    
        DMG_M9 = 43,
        VELOCITY_9MM = 220,
        RANGE_M9 = 6,
        CLIPSIZE_M9 = 15,

        START_INV = {}
    }
end

return v